#include <stdlib.h>
#include <stdbool.h>
#include "garbageMan.h"

int get_nearest(int);
static bool be_prime(int, Node * *);
static int get_remainder(int, Node * *);
static void add_1_prime(Node * *);
static bool sqr_less(int, int);
static void add(int, Node * *);
static void my_malloc(Node * *);
static void my_free(Node *);

static Node * head = NULL;   // 
int get_nearest(int x)
{
    int step = 0;         //
    int sign = -1;         //

    while (!be_prime(x, &head))
        x += (sign = -sign) * ++step;

    //my_free(head);
    return x;
}

bool be_prime(int x, Node * * pp) //ppжxǷΪ 
{
    if (x <= 1)
        return false;

    if (x == 2)
        return true;

    if (get_remainder(x, pp) == 0) // xpp0ֵ 
        return false;

    return true;
}

int get_remainder(int x, Node * * pp)//xpp
{
    while (*pp == NULL || sqr_less((*pp)->prime, x))// 
        add_1_prime(pp);                                 //һ 

    Node * p = *pp;

    while (p != NULL) {
        if ((x != p->prime) && x % p->prime == 0) // Modified!
            return 0;
        p = p->next;
    }

    return !0;
}

bool sqr_less(int n, int x)
{
    return n * n < x;
}

//͵ˣadd_1_prime()
void add_1_prime(Node * * pp)
{
    if (*pp == NULL) {
        add(2, pp);                     //һ 
        return;
    }

    switch ((*pp)->prime) {
    case  2: add(3, pp);
        return;
    case  3: add(5, pp);
        return;
        /* дcaseֻҪǰСĴ*/
    default:
    {
               int next_p = (*pp)->prime + 1;     //һ֮ʼһ 

               while (!be_prime(next_p, pp))
                   next_p++;

               add(next_p, pp);                    //һ 
               return;
    }
    }
}

//ʵʵadd_1_prime()
//void add_1_prime( Node * * pp )
//{
//   if ( * pp == NULL ) 
//   {
//       add ( 2 , pp );                     //һ 
//       return ;     
//   }
//   
//   int next_p = ( * pp )->prime + 1 ;     //һ֮ʼһ 
//   
//   while ( !be_prime( next_p , pp ) )
//      next_p ++ ;
//
//   add( next_p , pp );                    //һ 
//}

void add(int prime, Node * * pp)
{
    Node * temp;

    my_malloc(&temp);
    temp->prime = prime;
    temp->next = *pp;
    *pp = temp;
}

void my_malloc(Node * * p_p)
{
    if ((*p_p = (Node *)malloc(sizeof (** p_p))) == NULL)
        exit(1);
}

void my_free(Node * p)
{
    Node * temp;
    while ((temp = p) != NULL) {
        p = p->next;
        free(temp);
    }
}